import javax.script.Invocable;
import javax.script.ScriptEngine;
import javax.script.ScriptEngineManager;

public class InvocableDemo {

    public static void main(String[] args) {

        // create ScriptEngineManager
        ScriptEngineManager manager = new ScriptEngineManager();

        // get the ScriptEngine for JavaScript (js) 
        ScriptEngine engine = manager.getEngineByName("js");

        try {
            // execute script that contains the add function
            engine.eval("function add(a, b) " +
                    "{c = a + b; return c;}");        
            Invocable jsInvoke = (Invocable) engine;

            // call the add function, passing 10 and 5 
            Object result1 = jsInvoke.invoke("add", 
                    new Object[] {10, 5});
            System.out.println(result1);

            // call the add function throught the add method
            // in the Adder interface
            Adder adder = jsInvoke.getInterface(Adder.class);
            int result2 = adder.add(10, 5);
            System.out.println(result2);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
